unit uMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdMessage, IdBaseComponent, IdComponent, IdTCPConnection,
  IdTCPClient, IdExplicitTLSClientServerBase, IdMessageClient, IdSMTPBase,
  IdSMTP, StdCtrls, HTTPApp, HTTPProd;

const
  IniFileText: string = 'smtp.ini';

type
  TForm25 = class(TForm)
    IdSMTP1: TIdSMTP;
    IdMessage1: TIdMessage;
    btnEnviar: TButton;
    PageProducer1: TPageProducer;
    procedure FormCreate(Sender: TObject);
    procedure btnEnviarClick(Sender: TObject);
    procedure PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
      const TagString: string; TagParams: TStrings; var ReplaceText: string);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form25: TForm25;

implementation
     uses IniFiles, IdText, IdAttachmentFile;
{$R *.dfm}

procedure TForm25.btnEnviarClick(Sender: TObject);
var
  TextoPlano, CorpoHtml, TextoHtml: TIdText;
  ImagemAttach: TIdAttachmentFile;
begin
  try
    with IdMessage1, Recipients.Add do
    begin
      Address     := 'adilsonjr@tdstecnologia.com.br';
      Name        := 'Adilson Jr';
      Subject     := 'Voc Ganhou !!....';
      ContentType := 'multipart/alternative';
      Encoding := meMIME;
    end;

    TextoPlano := TIdText.Create(IdMessage1.MessageParts);
    TextoPlano.ContentType := 'text/plain';
    TextoPlano.Body.Add('Voc Ganhou um Prmio especial !!');

    CorpoHtml := TIdText.Create(IdMessage1.MessageParts);
    CorpoHtml.ContentType := 'multipart/related';

    TextoHtml := TIdText.Create(IdMessage1.MessageParts);
    TextoHtml.ContentType := 'text/html';
    TextoHtml.Body.Add(PageProducer1.Content);
    TextoHtml.ParentPart := CorpoHtml.Index;

    ImagemAttach := TIdAttachmentFile.Create(IdMessage1.MessageParts, 'tds.jpg');
    ImagemAttach.ContentType := 'image/jpg';
    ImagemAttach.ParentPart := CorpoHtml.Index;
    ImagemAttach.ContentDisposition := 'inline';
    ImagemAttach.ContentID := 'tds.jpg';

    IdSMTP1.Connect;
    IdSMTP1.Send(IdMessage1);
  finally
    IdSMTP1.Disconnect;
  end;
end;

procedure TForm25.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
begin
  try
    IniFile := TIniFile.Create
        (ExtractFilePath(Application.ExeName) + IniFileText);
    with IdSMTP1, IdMessage1 do
    begin
      Host         := IniFile.ReadString('SMTP', 'Host', '');
      Username     := IniFile.ReadString('SMTP', 'Username', '');
      Password     := IniFile.ReadString('SMTP', 'Password', '');
      From.Name    := IniFile.ReadString('FROM', 'Name', '');
      From.Address := IniFile.ReadString('FROM', 'Address', '');
      AuthType := atDefault;
    end;
  finally
    FreeAndNil(IniFile);
  end;
end;

procedure TForm25.PageProducer1HTMLTag(Sender: TObject; Tag: TTag;
  const TagString: string; TagParams: TStrings; var ReplaceText: string);
begin
  if TagString = 'TEXTO' then
    ReplaceText := 'DELPHI IS ROCKS !! CODE GEAR IS ROCKS !!'
end;

end.
